/*
*	test bed for ked -> vi interface function keyvi.c
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
KENV	kenv;
char	*
gdm()
{
	return(__DATE__);
}
undo()
{
	return(puts("undo"));
}
delcd()
{
	return(puts("delcd"));
}
void
terror()
{
	puts("<terror>\n");
	abort();
}
dolist()
{
	puts("<dolist>");
	wrcd(stdout,'f',kenv.folder);
	return(0);
}
getfold()		/* dummy */
{
	return(56);
}
extern	KARD	*kd;
extern	KBUF	kb;
KENV	kenv;
FILE	*fp;
main(argc,argv,argp)
int		argc;
char	**argv;
char	**argp;
{
	auto	char	ls[BUFSIZ];
	extern	char	*kgetenv();
	extern	char	*getenv();
	disnme(kenv.pname = "tkeyvi");
	kb.base = emalloc( 4096, kenv.pname);
	kb.bmax = kb.base + 4096;
	kenv.dosdos = isdos();
	puts("<keyvi test>");
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
	default:
	case	'?':	puts("Gname kgetenv");
					puts("gname getenv");
					puts("E     showenv");
					puts("F     fuxenv");
					puts("Kname keysread");
					puts("k     keyslist");
					puts("r     read a card");
					puts("Cname open a file");
					puts("X     close all open files");
					puts("v     vi for the current card");
	when	'X':	efclean(NULL);
	when	'G':	puts(kgetenv(strcnd(ls+1)));
	when	'g':	puts(getenv(strcnd(ls+1)));
	when	'E':	showenv(argp);
	when	'M':	keysmem(stderr);
	when	'F':	fuxenv(argp);
	when	'K':	keysread(keysfile(strcnd(ls+1)));
	when	'C':	fp = efopen(strcnd(ls+1),"r");
					fprintf(stderr,"%d = fileno(%s)\n",fileno(fp),ls+1);
	when	'!':	system(ls+1);
	when	'k':	keyslist(stdout);
	when	'R':	rewind(fp);
	when	'r':	getcd(0,0);
	when	'v':	if(kenv.keying == 0)	{
						errmsg("<no keys, use K file>\n");
						break;
						}
					kdovi(0,0,ls+1);
	when	'q':	exit(0);
					break;
	}
}
showenv(xp)
char	**xp;
{
	while(*xp)	fprintf(stderr,"%s\n",*xp++);
	return(0);
}
fuxenv(xp)
char	**xp;
{
	auto	int		zp = ZERO;
	while(*xp)	{
		/*environ[zp++] = *xp;*/
		strupr(*xp);
		strxty(*xp++,'/','\\');
		}
	return(0);
}
getcd(i,ty)			/* dummy */
{
	fputs("<getcd>",stdout);
	xrdcd(kb.base,kb.bmax,fp);
	xwrcd(kb.base,stdout);
	fflush(stdout);
	fputs("\r",stdout);
	return(NULL);
}
chgcd(i,ty)			/* dummy */
{
	wrcd(stdout,'f',56);
	fflush(stdout);
	return(NULL);
}
