#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include	"ksyskref.h"
/**/
#define		F_CARD	DA
#define		F_FILE	DB
#define		F_NUMI	DC
#define		F_EXPR	DD
#define		F_DADR	DE
/**/
/*EXTERNAL*/
extern	char	*texpr;
extern	char	*fnmsg;
extern	char	*nfmsg;
/**/
bsexpr(is)			/* process expression */
char	*is;		/* expression */
{
	auto	char	*isx = is;
	auto	char	ws[FNMSIZ];
	if(isnull(is))	{
		errmsg("bsexpr <null expression>\n");
		terror(FUBAR);
		}
	strxty(isx,'+',' ');
	strxty(isx,'&',' ');
	while( (int) (isx = xgnc(ws,ws+FNMSIZ-1,isx,':')))	{
		strxty(ws,'.',' ');
		addbs(ws,0,"expr");
		}
	return(ZERO);
}
doaexpr(fp,fn)		/* check one file for expressions */
FILE	*fp;		/* file pointer */
char	*fn;		/* file name */
{
	REG		BS		*bsx = bso;
	auto	char	*cp;
	auto	NOSIGN	wr_card = 0;
	auto	NOSIGN	rd_card = 0;
	auto	long	da = 0L;
	auto	int		nr;
/**/
	if(kenv.flags1 & F_DADR)	da = ftell(fp);
/**/
	while(1)	{
/**/
		cp = (*rdfunc)(bufo,bufu,fp);
		if(cp == NULL)	break;
		rd_card += 1;
		cp += 1;
/**/
		kpc(cp,bufu,bufo);
/**/
		bsx = bso;
		while(bsx->bs)	{
/**/
		nr = kpx(cp,bsx->bs);
#ifdef	DEBUG
		prpat(cp,stderr);
		prpat(bsx->bs,stderr);
#endif
		if(kenv.flags0 & DA)		nr = !nr;
/**/
			if((kenv.flags0 & DB) || nr)	{
				wr_card += 1;
				wrcard(stdout,nr,fn,rd_card,da);
				break;	/* to prevent multiple matches */
				}
/**/
		bsx += 1;
/**/
		}
	if(kenv.flags1 & F_DADR)	da = ftell(fp);
	}
/**/
	return(wr_card);
}
wrcard(ofp,nr,fn,cd,da)
FILE	*ofp;
int		nr;		/* found || no found */
char	*fn;	/* file name */
NOSIGN	cd;		/* card number */
long	da;		/* disk address */
{
	if(kenv.leisur & DA)	scr_cl(stdout);
	if(kenv.flags0 & DC)	{
		if(nr)				fprintf(ofp,"KREF FN %s\n",fnmsg);
		else				fprintf(ofp,"KREF NF %s\n",nfmsg);
		}
	if(kenv.flags1 & F_FILE)	fprintf(ofp,"FILE %s\n",fn);
	if(kenv.flags1 & F_NUMI) 	fprintf(ofp,"NUMI %u\n",cd);
	if(kenv.flags1 & F_EXPR) 	fprintf(ofp,"EXPR %s\n",texpr);
	if(kenv.flags1 & F_DADR) 	fprintf(ofp,"DADR %ld\n",da);
	if(kenv.flags1 & F_CARD)	{
		if(kenv.folder) 	xwrcdf(bufo,stdout,kenv.folder,NULL);
		else				xwrcd(bufo,stdout);
		if(kenv.leisur & DB)	{
			if(query(stdout) == 'q')	exit(0);
			}
		}
	return(ZERO);
}
