#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#define		NO_KEYS
/**/
#include	"ksyskref.h"
/**/
#define		WORD	'\001'
#define		EOW		'\0'
#undef		EOW
#define		EOW		'\002'
/**/
/*EXTERNAL*/
/**/
#ifdef	TEST
char	ls[BLKSIZ];
char	ps[BLKSIZ];
char	ts[BLKSIZ];
KENV	kenv;
main()
{
	auto	int	flags = 0;
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
	case	'?':	puts("r file > target");
					puts("#n    diagnostic level");
					puts("@     close stdin");
					puts(">pat  compile target");
					puts("<pat  compile card");
					puts("C     compression toggle");
					puts("      execute");
					break;
	case	'r':	rdtest(strcnd(ls+1),ts);
					break;
	case	'C':	if(flags & DA)	kpcset(flags &= ~DA);
					else			kpcset(flags |= DA);
					break;
	case	'#':	kenv.diagno = atoi(ls+1);
					break;
	case	'@':	fclose(stdin);
					break;
	case	'>':	kpc(ts,ts+BLKSIZ,ls+1);
					prkpc(ts,stdout);
					break;
	case	'<':	kpc(ps,ps+BLKSIZ,ls+1);
					prkpc(ps,stdout);
					break;
	default:		printf("%d\n",kpx(ps,ts));
					break;
	}
	exit(0);
}
rdtest(ls,ts)
char	*ls;
char	*ts;
{
	auto	FILE	*fp;
	if(!(fp = efopen(ls,kenv.dosdos ? "rb" : "r")))	return(ZERO);
	while(xrdcd(ls,ls+BLKSIZ-1,fp))	{
	kpc(ps,ps+BLKSIZ-1,ls);
	if(kpx(ps,ts))	xwrcdf(ls,stdout,56,NULL);
	}
	fclose(fp);
	return(ZERO);
}
prkpc(is,fp)
char	*is;
FILE	*fp;
{
	return(prpat(is,fp));
}
#endif
char	*
kpc(os,us,is)		/* compile pattern */
char	*os;
char	*us;
char	*is;
{
	REG		char	*isx = is;
	REG		char	*osx = os;
	REG		char	*usx = us;
	REG		char	*cnt = os;
/*
**	WORD, SIZE, word, EOW
**	multiple blanks and punctuation removed
*/
	*osx = ZERO;
	while(osx < usx && *isx != ZERO)	{
/**/
	if(isalnum(*isx))	{
		*osx++ = WORD;
		cnt = osx++;
		while(*isx != ZERO)
		if(isspace(*isx))	break;
		else
		if(islower(*isx))	*osx++ = *isx++;
		else
		if(isdigit(*isx))	*osx++ = *isx++;
		else
		if(isupper(*isx))	{
			*osx++ = tolower(*isx);
			isx += 1;
			}
		else				isx += 1;
		*osx++ = EOW;
		*cnt = (char) (osx - cnt) - 2;
		}
	else
#ifdef	NO_KEYS
	if(*isx == LF)	{
		isx += 1;
		while(*isx != ZERO && isalnum(*isx))	++isx;
		}
	else
#endif
/**/
	if(isspace(*isx))	++isx;
	else				++isx;
/**/
	}
	*osx++ = ZERO;
/**/
	if(osx >= usx)	{
		errmsg("kpc <overflow> %u %u\n",os,us);
		*os = ZERO;
		}
/**/
	return(osx);
}
char	*
kpcc(is)
char	*is;
{
	REG		char	*isx = is;
	REG		int	tcnt = 0;
	while(*isx != ZERO)
	if(*isx == WORD)	{
#ifdef	KPCC_DEBUG
		fputs("WORD ",stdout);funxesc(isx,stdout);
		fputs("WORD ",stdout);prpat(isx,stdout);
#endif
		tcnt = (int) isx[1];
		isx[tcnt+2] = ZERO;
#ifdef	KPCC_DEBUG
		fputs("TARG ",stdout);funxesc(isx,stdout);
		fputs("NEXT ",stdout);prpat(isx+tcnt+3,stdout);
#endif
		if(kpx(isx + tcnt + 3, isx))	{
			strcpy(isx, isx + tcnt + 3);
			continue;
			}
		isx[tcnt+2] = EOW;
		isx += (tcnt + 3);
		}
	else	{
		fputs("\007kpcc\n",stderr);
		terror(FUBAR);
		}
	return(is);
}
kpx(cs,ts)
char	*ts;	/* target string(s) */
char	*cs;	/* text (card) */
{
	REG		char	*csx = cs;
	REG		char	*tsx = ts;
	REG		int		ccnt;
	REG		int		tcnt;
	if(*tsx == ZERO)	return(0);
	while(csx && *tsx != ZERO)	{
/**/
/**/
	if(*tsx == WORD)	{
		tcnt = (int) *++tsx;
		tsx += 1;
		{
			csx = cs;
			while(*csx != ZERO)	{
/**/
/**/
			if(*csx == WORD)	{
				ccnt = (int) *++csx;
				csx += 1;
/**/
/**/
				if(ccnt != tcnt)	;
				else
				if(*csx != *tsx)	;
				else
				if(strncmp(csx+1,tsx+1,ccnt-1) == 0)	break;
				csx += (ccnt + 1);
				}
			else	{
				funxesc(cs,stderr);
				errmsg("kpx <pattern error> csx\n");
				terror(FUBAR);
				}
			}
			if(*csx == ZERO)	return(ZERO);
		}
		tsx += (tcnt + 1);
		}
	else	{
		funxesc(ts,stderr);
		errmsg("kpx <pattern error> tsx\n");
		terror(FUBAR);
		}
	csx += 1;
	}
	return(1);
}
char	*
fmtpat(os,us,is)		/* format pattern in os */
char	*os;			/* output string */
char	*us;
char	*is;			/* pattern */
{
	static	char	*here = "fmtpat";
	REG		char	*isx = is;
	REG		char	*osx = os;
	REG		char	*usx = us;
	REG		int		cnt;
/**/
	if(isnull(is))	{
		errmsg("%s <null pattern>\n",here);
		terror(FUBAR);
		}
/**/
	*osx = 0;
/**/
	while(osx < usx && *isx != 0)	{
	if(*isx == WORD)	{
		isx += 2;	/* skip count */
		while(osx < usx && *isx != ZERO && *isx != EOW)
			*osx++ = *isx++;
		if(*isx == EOW)	{
			isx += 1;
			*osx++ = ' ';
			}
		}
	else	{
		errmsg("%s <pattern error>\n",here);
		terror(FUBAR);
		}
	}
/**/
	*osx++ = 0;
/**/
	if(osx >= usx)	{
		errmsg("fmtpat <overflow>\n");
		abort();
		}
/**/
	return(os);
}
prpat(is,fp)		/* print pattern */
char	*is;		/* pattern */
FILE	*fp;		/* out file */
{
	REG		char	*isx = is;
	while(*isx != 0)	{
	if(*isx == WORD)	{
		isx += 2;
		while(*isx != ZERO && *isx != EOW)	putc(*isx++,fp);
		if(*isx == EOW)	{
			putc(' ',fp);
			isx += 1;
			}
		}
	else	{
		errmsg("prpat <pattern error>\n");
		terror(FUBAR);
		}
	}
	putc('\n',fp);
	return(ZERO);
}
