#include	"ktheader.h"
/**/
static	char	*iu;
/**/
doscan(dlist,ndir)
char	**dlist;
int		ndir;
{
	auto	int		ix;
	auto	char	ib[FNMSIZ];
/**/
	iu = ib + FNMSIZ - 16;
/**/
	for(ix = 0; ix < ndir; ix++)	{
		strcpy(ib,dlist[ix]);
		fscan(ib);
		}
	return(ZERO);
}
#if		DIRTYPE	==	1
/**/
void
dscan(is)       /* dscan for BSD */
char    *is;    /* current file */
{
	extern  int             alphasort();
	REG     int             i;
	REG     int             nid;
	auto    char            *lx;
	auto    struct  direct  **dl;
/**/
	lx = is + strlen(is);
	*lx++ = '/';
	*lx = ZERO;
	nid = scandir(is,&dl,NULL,alphasort);
	for(i = 0; i < nid; i++)    {
		if(strcmp(dl[i]->d_name,".") == 0)    continue;
		if(strcmp(dl[i]->d_name,"..") == 0)   continue;
		strcpy(lx,dl[i]->d_name);
		free(dl[i]->d_name);
		fscan(is);
		}
	*--lx = ZERO;
	free(dl);
	return;
}
#endif
#if		DIRTYPE == 0
#include	<fcntl.h>
newcmp(os,is)
struct	direct	*os;
struct	direct	*is;
{
	return(strcmp(os->d_name,is->d_name));
}
void
dscan(is)	/* dscan for SCO Xenix */
char    *is;
{
	struct  direct  *dbuf;
	struct	direct	*dbx;
	auto	char    *lx;
	auto	int		i;
	auto	int		fd;
	auto	NOSIGN	sd;
	auto	NOSIGN	nd;
/**/
	lx = is + strlen(is);
	if(lx >= iu)	{
		errmsg("dscan <long name>\n");
		exit(FUBAR);
		}
	if(lx[-1] != '/') *lx++ = '/';
	*lx = ZERO;
/**/
	sd = (NOSIGN) sbuf.st_size;
	nd = sd / sizeof(struct direct);
	dbx = dbuf = (struct direct *) emalloc( sd, "dscan");
/**/
	if((fd = open(is,O_RDONLY)) < 0)	{
		prterr(is);
		*--lx = ZERO;
		return;
		}
/**/
	read(fd,(char *) dbuf,sd);
/**/
	qsort((char *) dbuf, nd, sizeof(struct direct), newcmp);
/**/
	while(nd-- >= 1)	{
		if(dbx->d_ino == 0)          		;
		else
		if(strcmp(dbx->d_name,".") == 0)    ;
		else
		if(strcmp(dbx->d_name,"..") == 0)   ;
		else	{
/**/
#define	MAXNAME		14
		strncpy(lx,dbx->d_name,MAXNAME);
		lx[MAXNAME] = ZERO;		/* important */
		fscan(is);
/**/
			}
		dbx += 1;
		}
/**/
	close(fd);
/**/
	free((char *) dbuf);
/**/
	*--lx = ZERO;
/**/
	return(ZERO);
}
#endif
#if		DIRTYPE	== 2
/**/
#include	<dos.h>
/**/
alphasort(os,is)
char	**os;
char	**is;
{
	return(stricmp(*os,*is));
}
#define		NUMFILES	64
char	**
makelp(old,seg)
char	*old;
int		seg;
{
	auto	int		req;
	auto	char	*rex;
	req = NUMFILES * sizeof(char **) * seg;
	if(seg == 1)	rex = emalloc(req,"makelp");
	else			rex = erealloc(old,req,"makelp");
	return((char **) rex);
}
#define		DOSDIR		FA_DIREC
#define		DOSSYS		FA_SYSTEM
#include	<dir.h>
void
dscan(is)	/* dscan for MSDOS */
char	*is;
{
	auto	struct	ffblk	ffblk;
	auto	int				done;
	auto	char			fs[FNMSIZ];
	auto	char			bs[FNMSIZ];
	auto	char			**lp = NULL;
	auto	int				nlp = 0;
	auto	int				seg = 1;
	auto	int				ix;
/**/
	strcpy(bs,is);
	strcat(bs,"/");
	strcat(bs,"*.*");
	strdos(bs);
/**/
	done = findfirst(bs,&ffblk,DOSSYS);
	while(!done)	{
/**/
		fs[0] = ZERO;
		strcpy(fs,is);
		strcat(fs,"/");
		strcat(fs,ffblk.ff_name);
/**/
		if(!(nlp % NUMFILES))	lp = makelp((char *) lp,seg++);
		strdos(fs);
		lp[nlp++] = strsave(fs);
/**/
		done = findnext(&ffblk);
		}
	qsort( (char *) lp, nlp, sizeof(char **), alphasort);
	for(ix = 0; ix < nlp; ix++)	{
		fscan(lp[ix]);
		free_if(lp[ix]);
		}
	free_if( (char *) lp);
/**	scan for directories **/
	done = findfirst(bs,&ffblk,DOSDIR);
/**/
/*
|	note that directories are NOT sorted
*/
	while(!done)	{
/**/
		fs[0] = ZERO;
		if(ffblk.ff_attrib & DOSDIR)	{
			if(strcmp(ffblk.ff_name,".") == ZERO)		;
			else
			if(strcmp(ffblk.ff_name,"..") == ZERO)	;
			else	{
				strcpy(fs,is);
				strcat(fs,"/");
				strcat(fs,ffblk.ff_name);
				strdos(fs);
				fscan(fs);
			}
		}
/**/
		done = findnext(&ffblk);
		}
/**/
	return;
}
#endif
