/*DOSLIB*/
/*UNXLIB*/
#ifdef	MSDOS
/*
*	These routines should be put in the library only for compilation
*	under MSDOS.  Some are necessary for TURBOC, others for MICRO-
*	SOFT C, others for both.
*
*	The bracketing #ifdef MSDOS is to render this file NULL if it
*	is inadvertently included in a UNIX/XENIX library.
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	<dos.h>
/*
**	dummy functions for msdos when there are no equivalents
**	in the MSDOS/XENIX library
*/
/**/
/*EXTERNAL*/
extern	KENV	kenv;
/**/
/*
*	ITEMS REQUIRED FOR MSDOS COMPILATION WITH TURBOC
*/
#ifdef	__TURBOC__
getpid()
{
	auto	long	seed;
	static	int		lock = NO;
	static	int		pid = ZERO;
	if(lock == NO)	{
		time(&seed);
		srand( (NOSIGN) seed );
		lock = YES;
		pid = rand();
		}
	return(pid);
}
#else	__TURBOC__
/*
*	ITEMS REQUIRED FOR MSDOS COMPILATION WITH MICROSOFT XENIX
*/
NOSIGN
sleep(ty)
NOSIGN	ty;
{
	auto	long	st;
	auto	long	en;
	time(&st);
	en = st + (long) ty;
	do	{
		time(&st);
		}	while(st <= en)	;
	return(ty);
}
#endif	__TURBOC__
/*
*	ITEMS REQUIRED FOR MSDOS COMPILATION (UNIX DUMMIES)
*/
char	*
getlogin()
{
	return( NULL );
}
#ifdef	IOCTL
/*
*	WARNING: TURBOC IOCTL HAS NO RELATION TO UNIX/XENIX IOCTL
*/
ioctl()
{
	spurious("ioctl");
	return(0);
}
#endif	IOCTL
FILE	*
popen()
{
	spurious("popen");
	return(NULL);
}
FILE	*
pclose(fp)
FILE	*fp;
{
	spurious("pclose");
	return(fp = NULL);
}
times()
{
	spurious("times");
	return(0);
}
wait()
{
	spurious("wait");
	return(0);
}
alarm(ty)
NOSIGN	ty;
{
	static	NOSIGN	ly = ZERO;
	ly ^= ty;
	ty ^= ly;
	ly ^= ty;
	return(ly);
}
link(os,is)
char	*os;
char	*is;
{
	unlink(is);
	return(rename(os,is));
}
#endif	MSDOS
void
spurious(is)
char	*is;
{
	errmsg("<spurious MSDOS call> '%s'\n",is);
	terror(69);
}
