=========
VARIABLE TYPES AND DECLARATIONS
=========
int     one;        integer/pointer variable
int     two[nnn];   integer/pointer array
char    one;        character variable
char    two[nnn];   character (string) array
$key                ked key
=========
CONSTANTS
=========
"string"        string constant (in formats, function calls)
69              numerical constant (integers only)
'c'             character constant
'\000'          octal constant
=========
INITIALIZATION
=========
strcpy(string,"start");     strings
x = 69;                     numerical
=========
ARITHMETIC OPERATORS (NUMERIC VARIABLES)
n1 + n2                 addition
n1 - n2                 subtraction
n1 * n2                 multiplication
n1 / n2                 division
n1 % n2                 remainder
n1 = n2                 assignment
n1 += n2                n1 = n1 + n2;
n1 -= n2                n1 = n1 - n2;
n1 *= n2                n1 = n1 * n2;
n1 /= n2                n1 = n1 / n2;
n1 %= n2                n1 = n1 % n2;
=========
LOGICAL OPERATORS (NUMERIC VARIABLES)
=========
n1 == n2                equal
n1 != n2                not equal
n1 >= n2                greater than or equal
n1 >  n2                greater than
n1 <= n2                less than or equal
n1 <  n2                less than
n1 && n2                logical and
n1 || n2                logical or
!n1                     logical negation
=========
RESERVED WORDS/SYNTAX
=========
for(expr_1; expr_2; expr_3) statement;
=========
while(expression)   statement;
=========
break               stop the current while or for loop
continue            start the next iteration of a for or while
=========
if(expression)      statement;
else                statement;
=========
GROUPING/PRECEDENCE
=========
(expression)
{statement;}
=========
FORMAT CODES
=========
(code)              (result)
\b                  backspace
\f                  formfeed
\n                  new line
\r                  carriage return
\"                  " (within string)
\000                octal constant
^X                  control character X
%B
%I
%n                  \n
%N                  \N
%[BIURP]            \fB, \fI, \fU, \fR, \fP
%q                  '
%Q                  "
%S                  string (folded)
%s                  string (using printf specifications)
%d                  number (using printf specifications)
=========
COMMENTS
=========
/* comment */       anywhere
# comment           ends of lines
=========
