#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
#include	"ksysprot.h"
#include	"kawkfunc.h"
void
klitrep(na,ap)
int     na;
DATUM   *ap;
{
/*  litrep(os,us,is,ts,rs,gl) */
    rdx.v.ptr = litrep(ap[0].v.ptr,
        ap[0].v.ptr+ap[1].v.ivalu,
        ap[2].v.ptr,
        ap[3].v.ptr,
        ap[4].v.ptr,
        ap[5].v.ivalu);
    pusher = spush;
}
char    *
litrep(os,us,ts,ps,rs,ns)     /* literal string replace */
char    *os;    /* output string */
char    *us;    /* upper limit of os */
char    *ts;    /* target (input) string */
char    *ps;    /* pattern string */
char    *rs;    /* replacement string */
NOSIGN	ns;     /* number of replacements */
{
	REG		char	*tsx = ts;
	REG		char	*osx = os;
	REG		char	*usx = us;
	auto	int		lps = strlen(ps);
	auto	int		lts = strlen(ts);
/**/
	ns = ns ? ns : HUGE;
/**/
	while(osx < usx && ns >= 1 && *tsx != ZERO)		{
/**/
	if(*tsx == *ps && strncmp(tsx,ps,lps) == ZERO)	{
		REG		char	*rsx = rs;
/**/
		while(osx < usx && *rsx != ZERO)	
			*osx++ = *rsx++;
/**/
		ns -= 1;
		tsx += lps;
		lts -= lps;
		}
	else	{
		*osx++ = *tsx++;
		lts -= 1;
		}
/**/
	}
	if(lts >= 1)	{
		while(osx < usx && *tsx != 0)	*osx++ = *tsx++;
		}
/**/
	*osx = ZERO;
/**/
	return(osx);
}
