#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include	"ksyskwik.h"
/*EXTERN*/
#ifdef		CAN_PROTO
extern int cpat(char *);
#else		/*CAN_PROTO*/
extern int cpat();
#endif		/*CAN_PROTO*/
/**/
svepat(is)	/* compile and save patterns */
char	*is;
{
	auto	char	*err;
/**/
/**/
	if(isnull(is))	is = curpat;
	if(isnull(is))	{
		errmsg("svepat <no pattern>\n");
		terror(FUBAR);
		}
	curpat = free_if(curpat);
	curpat = strsave(is);
	if(!curpat)	{
		errmsg("svepat <no core>\n");
		terror(FUBAR);
		}
	kpc(curkpc,curkpc + BLKSIZ - 1, curpat);
/***compile for krep style search***/
	err =(char *) cpat(is);
	if(err)	{
		curpat = free_if(curpat);
		terror(FUBAR);
		}
	return(0);
}
makepat(is,ty)
char	*is;
NOSIGN	ty;
{
	auto	char	ws[BLKSIZ];
	auto	char	*wsx = ws;
	auto	char	*wsu = ws + BLKSIZ - 1;
	auto	char	*psx = NULL;
/*
**	patterns beginning with | or & are expanded to
**	(word&word&word) or (word|word|word)
*/
	*wsx++ = '(';
	while((int)(is = strtoc(psx = is,' ')))	{
		strcnd(psx);
		if(isnull(psx))	continue;
		wsx = strkat(wsx,wsu,psx);
		if(wsx < wsu && !isnull(is))	*wsx++ = ty;
		}
	if(wsx < wsu)	*wsx++ = ')';
	*wsx = ZERO;
	return(svepat(ws));
}
