/*COMLIB*/
/**/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
/*EXTERN*/
extern	KENV	kenv;
/**/
char	*
blkrd(is)
char	*is;
{
	auto	char	*rx;
	auto	long	fs;
	auto	FILE	*fp;
	auto	int		fd;
	auto	int		nci;
	auto	char	*rm = kenv.dosdos ? "rb" : "r";
	fs = filesize(is);
	if(fs <= 1L)	{
		errmsg("blkrd <bad file> '%s'\n",is);
		fubar(FUBAR);
		}
	rx = emalloc( (unsigned) (fs + 1),"blkrd");
	if(!rx)			{
		errmsg("blkrd <no core> '%u'\n",(unsigned) (fs +1) );
		fubar(FUBAR);
		}
	if(!(fp = efopen(is,rm)))	fubar(FUBAR);
	fd = fileno(fp);
	nci = read(fd,rx,(int) fs);
	fp = xfclose(fp);
	if(nci != (int) fs)	{
		errmsg("blkrd <bad read> '%u' != '%u'\n",nci,(int) fs);
		}
	rx[(int)fs] = ZERO;
	return(strxty(rx,CR,ZERO));
}
#ifdef	TEST
KENV	kenv;
blkprt(os,nc)
char	*os;
int		nc;
{
	while(nc-- >= 1)	putc(*os++,stderr);
	return(ZERO);
}
main(argc,argv)
int		argc;
char	*argv[];
{
	auto	char	ls[BUFSIZ];
	auto	char	*xp;
	kenv.dosdos = isdos();
	disnme(kenv.pname = "blkrd");
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
	case	'!':	system(ls+1);
	when	'D':	kenv.dosdos = ZERO;
	when	'd':	kenv.dosdos = 1;
	when	'r':	xp = blkrd(strcnd(ls+1));
	when	'f':	free(xp);
	when	'p':	puts(xp);
	other:			puts("!,r,f,p");
					break;
	}
}
#endif
