/*COMLIB*/
#define		DEBUG
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#define     SQ  '\''    /* single quote */
#define     DQ  '"'     /* double quote */
/**/
extern	char	*cpytoc();
extern	char	*cpytsp();
/**/
getqs(xp,nx,is)
char	**xp;	/* pointers to split segments */
int		nx;		/* max elements in xp */
char	*is;	/* string to split */
{
/*
	split a string in the fashion of the shell.
	within a DQ string, SQ is not significant
	within a SQ string, DQ is not significant
*/
	REG		unsigned	char	*isx = is;
	REG		unsigned	int		nxu = nx;
/**/
	for(nx = 0; nx < nxu; nx++)	xp[nx] = "";
	nx = 0;
/**/
	while(nx < nxu && *isx != ZERO)	{
	if(isspace(*isx))	++isx;
	else
	if(*isx == DQ || *isx == SQ)	{
		isx = cpytoc(xp[nx++] = isx + 1,*isx);
		}
	else	{
		isx = cpytsp(xp[nx++] = isx);
		}
	}
	return(nx);
}
char	*
cpytsp(is)	/* copy to next space */
char	*is;
{
	REG		unsigned	char	*isx = is;
	REG		unsigned	char	*osx = is;
	while(*isx != ZERO)	{
	if(isspace(*isx))					break;
	if(*isx == ESC && isspace(isx[1]))	++isx;
	*osx++ = *isx++;
	}
	if(*isx != ZERO)					*isx++ = ZERO;
	*osx = ZERO;
	return(isx);
}
char	*
cpytoc(is,cx)	/* copy to next cx */
char	*is;
int		cx;
{
	REG		unsigned	char	*isx = is;
	REG		unsigned	char	*osx = is;
	while(*isx != ZERO)	{
	if(*isx == cx)						break;
	else
	if(*isx == ESC && isx[1] == cx)		++isx;
	*osx++ = *isx++;
	}
	if(*isx != ZERO)					*isx++ = ZERO;
	*osx = ZERO;
	return(isx);
}
#ifdef  TEST
KENV	kenv;
void
terror(ty)
int		ty;
{
	exit(ty);
}
main()
{
	auto	char	ls[FNMSIZ];
	auto	char	*lp[16];
	auto	int     np;
	auto	int     nu = 16;
	auto	int		i;
	while(putchar('?'),fflush(stdout),gets(ls)) {
	if(ls[0] == '#')	{
		nu = atoi(ls+1);
		continue;
		}
	xesc(ls);
	np = getqs(lp,nu,ls);
	for(i = 0; i < np; i++) {
		printf("(%d) ",i);
		funxesc(lp[i],stderr);
		printf("(%d) <%s>\n",i,lp[i]);
		}
	}
}
#endif
