/*DOSLIB*/
/*UNXLIB*/
#define		DEBUG
#undef		DEBUG
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include	<sys/types.h>
#include	<sys/stat.h>
/**/
#ifdef	V29
#undef	void	/* already has dumb definition */
#endif	V29
/**/
/*EXTERN*/
extern 	int 	hint();
extern	int		helpfind();
extern	int		mtime();
extern	int		kbundle();
extern	int		delete();
extern	int		kchmod();
extern	int		copier();
extern	int		linker();
extern	int		mover();
extern	int		kutime();
/*GLOBAL*/
char	*target;			/* target directory */
char	*select;			/* file pattern to select */
char    ls[BUFSIZ];			/* line buffer */
int		mode;				/* mode for chmod */
int		days;				/* days for mtime */
KENV	kenv;
/**/
void
terror(ty)
{
	exit(ty);
}
main(argc,argv)
int		argc;
char	*argv[];
{
/**/
	kenv.dosdos = isdos();
/**/
	disnme(kenv.pname = "helpfind");
	exit(cmdxrc(argc,argv,helpfind,"helpfind.xrc"));
	return(0);	/* LINT */
}
helpfind(argc,argv)
int		argc;
char	*argv[];
{
	auto	FUNCP	func;
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
	if(cmdnum(argc,argv,'h',0,1))	{
		if(isatty(1))	kenv.leisur = DA | DB;
		whoru(stdout);
/* ### Warning helpfind.c 65: Call to function 'hint' with no prototype in function helpfind === */
		hint(kenv.pname);
		}
/**/
	func = (FUNCP) delete;
	kenv.flags0 = cmdnum(argc,argv,'i',0,DA|DB);
	if(cmdnum(argc,argv,'m',0,1))	{
		func =(FUNCP) mtime;
		days = cmdnum(argc,argv,'m',1,1);
		}
	target = cmdstr(argc,argv,'d',kgetenv("HOME"));
	select = cmdstr(argc,argv,'s',NULL);
	if(cmdnum(argc,argv,'M',0,1))	func = (FUNCP) mover;
	if(cmdnum(argc,argv,'c',0,1))	func = (FUNCP) copier;
	if(cmdnum(argc,argv,'l',0,1))	func = (FUNCP) linker;
	if(cmdnum(argc,argv,'t',0,1))	func = (FUNCP) kutime;
	if(cmdnum(argc,argv,'b',0,1))	func = (FUNCP) kbundle;
	if(cmdnum(argc,argv,'u',0,1))	func = (FUNCP) delete;
	if(cmdnum(argc,argv,'p',0,1))	{
		func = (FUNCP) kchmod;
		sscanf(cmdstr(argc,argv,'p',"0644"),"%o",&mode);
		}
/* ### Warning helpfind.c 86: Call to function with no prototype in function helpfind === */
	(*func)();
	exit(0);
	return(0);	/* LINT */
}
kutime()	/* set file times from list */
{
	struct	UT	{
			long	at;
			long	mt;
			}	ut;
	auto	char	fn[FNMSIZ];
	while(fgetls(ls,ls+BUFSIZ-1,stdin))	{
		sscanf(ls,"%s %ld",fn,&ut.mt);
		ut.at = ut.mt;
/* ### Warning helpfind.c 100: Call to function 'utime' with no prototype in function kutime === */
		utime(fn,&ut);
		}
	return(0);
}
/**/
mtime()
{
	auto	long	cutoff = (long) days * 24L * 3600L;
	extern	long	time();
	struct	stat	sbuf;
/**/
	cutoff = time(NULL) - cutoff;
/**/
	while(fgetlw(ls, ls + BUFSIZ - 1, stdin))	{
/**/
		if(stat(ls,&sbuf))	{
/* ### Warning helpfind.c 116: Call to function 'prterr' with no prototype in function mtime === */
			prterr("mtime: '%s'",ls);
			continue;
			}
/**/
		if(sbuf.st_mtime >= cutoff)	puts(ls);
		else						continue;
		}
	return(ZERO);
}
kchmod()
{
	auto	int		res;
	while(fgetlw(ls,ls+BUFSIZ-1,stdin))	{
/* ### Warning helpfind.c 129: Call to function 'chmod' with no prototype in function kchmod === */
		res = chmod(ls,mode);
		if(res)	printf("c! %s\n",ls);
	}
	return(ZERO);
}
isafile(is)
char	*is;
{
		auto	struct	stat	sb;
		if(stat(is,&sb) < 0)	{
/* ### Warning helpfind.c 139: Call to function 'prwho' with no prototype in function isafile === */
			prwho(" cannot stat '%s'\n",is);
			return(0);
			}
		if((sb.st_mode & S_IFMT) & S_IFREG)	return(1);
		else	{
/* ### Warning helpfind.c 144: Call to function 'prwho' with no prototype in function isafile === */
			prwho(" not an ordinary file '%s'\n",is);
			return(0);
			}
}
askuser(is)
char	*is;
{
	auto	char	ws[FNMSIZ];
	static	FILE	*fp = NULL;
	auto	char	*tty;
/**/
	if(kenv.dosdos)	tty = "con";
	else			tty = "/dev/tty";
/**/
	if(!fp && !(int) (fp = efopen(tty,"r")))	terror(FUBAR);
/**/
	fprintf(stdout,"%s ?",is);
/**/
	fgetls(ws,ws+FNMSIZ-1,fp);
/**/
	if(ws[0] == 'y' || ws[0] == 'Y')	return(ZERO);
	else								return(1);
/**/
}
kbundle()
{
	auto	char	*bn;
	while(fgetlw(ls,ls+BUFSIZ-1,stdin))	{
		bn = strrchr(ls,'/');
		if(bn)	bn += 1;
		else	bn = ls;
		printf("cat > %s <<\\END:%s\n",ls,bn);
/* ### Warning helpfind.c 176: Call to function 'kat' with no prototype in function kbundle === */
		kat(ls);
		printf("END:%s\n",bn);
	}
	return(ZERO);
}
kat(is)
char	*is;
{
	REG		FILE	*fp;
	REG		int		cx;
/**/
	if(!(int) (fp = efopen(is,"r")))		return(ZERO);
/**/
	while((cx = getc(fp)) != EOF)	putchar(cx);
	fp = xfclose(fp);
/**/
	return(ZERO);
}
mover()
{
/* ### Warning helpfind.c 196: Call to function 'actor' with no prototype in function mover === */
	return(actor(0));
}
copier()
{
/* ### Warning helpfind.c 200: Call to function 'actor' with no prototype in function copier === */
	return(actor(1));
}
linker()
{
/* ### Warning helpfind.c 204: Call to function 'actor' with no prototype in function linker === */
	return(actor(2));
}
delete()
{
/* ### Warning helpfind.c 208: Call to function 'actor' with no prototype in function delete === */
	return(actor(3));
}
actor(ty)
{
	auto	char	ws[FNMSIZ];
	static	int		tell = NO;
	static	char	*name[] = {
		"move",
		"copy",
		"link",
		"delete",
		}	;
/**/
	if((kenv.flags0) && !tell)	{
		tell += 1;
/* ### Warning helpfind.c 223: Call to function 'prwho' with no prototype in function actor === */
		prwho("\007 <answer y to %s files>\n",name[ty]);
/* ### Warning helpfind.c 224: Call to function 'prwho' with no prototype in function actor === */
		prwho(" <target for moves, links, copies> %s\n",target);
		if(select)
/* ### Warning helpfind.c 226: Call to function 'prwho' with no prototype in function actor === */
		prwho(" <pattern for selection> '%s'\n",select);
		}
/**/
	while(fgetlw(ls,ls+BUFSIZ-1,stdin))	{
/**/
		if(select && !bshpat(ls,select))	continue;
/**/
/* ### Warning helpfind.c 233: Call to function 'isafile' with no prototype in function actor === */
		if(!isafile(ls))	continue;
/**/
		sprintf(ws,"%s/%s",target,ls);
/**/
		if(kenv.flags0 & DB)	{
			if(filesize(ws) >= 1L)	{
/* ### Warning helpfind.c 239: Call to function 'prwho' with no prototype in function actor === */
				prwho("\007 <exists> %s\n",ws);
				}
			}
/**/
/* ### Warning helpfind.c 243: Call to function 'askuser' with no prototype in function actor === */
		if(kenv.flags0 && askuser(ls))	continue;
/**/
		if(ty == 0)	{
			linkorcopy(ls,ws);
			}
		else
		if(ty == 1)	{
/* ### Warning helpfind.c 250: Call to function 'fcopy' with no prototype in function actor === */
			if(fcopy(ws,ls))	terror(FUBAR);
			}
		else
		if(ty == 2)	{
			if(link(ls,ws))	{
/* ### Warning helpfind.c 255: Call to function 'prterr' with no prototype in function actor === */
				prterr("%s -> %s",ls,ws);
				continue;
				}
			}
		if(ty == 3)	{
			if(unlink(ls))	{
/* ### Warning helpfind.c 261: Call to function 'prterr' with no prototype in function actor === */
				prterr("%s",ls);
				continue;
				}
			}
		}
	return(ZERO);
}
hint(ty)
int		ty;
{
static	char	*hx[] = {
"=helpfind [-options]",
"*   reads the standard input for a list of file names performing",
"*   the option specified.  unlink is intended to be driven by find  ",
"*   or lc -1 through a pipe.",
"=OPTIONS",
"-b      bundle the files for cat - << processing",
"-i      query before acting (-u function)",
"-mNNN   only pass files modified with the last NNN days [1]",
"-p NNN  assign permission NNN",
"-t      file modification times set from a name time list",
"-u      unlink function [default]",
"=",
"~",
"=EXAMPLES",
"*       find . -type f -name '*.o' -print | helpfind",
"*           removes (rapidly) all the .o files in the current",
"*           directory and its subdirectories.",
"*       lc -1 *.obj|helpfind -i",
"*           removes (with query) all the .obj files in the",
"*           current directory (MSDOS)",
"=",
}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	exit(ty);
	return(ty);	/* LINT */
}
